OrderedEnvir {
	var <envir, <order;
	
	*new { arg envir;
		^super.newCopyArgs(envir ?? { Environment.new(32, Environment.new) }, LinkedList.new)
	}
	*make { arg function;
		^this.new.make(function)
	}
	*use { arg function;
		^this.new.use(function)
	}
		
	put { arg key, obj;
		var node = envir.at(key);
		if(node.isNil) {
			node = OrderedEnvirNode.new(key, obj);
			order.addNode(node);
			envir.put(key, node);
		} {
			node.obj = obj
		};
	}
	
	at { arg key;
		var node = envir.at(key);
		^node !? { node.obj }	
	}
	
	push { 
		if(currentEnvironment !== this) {
			Environment.push(this)
		} { "this environment is already current".warn } 
	}

	
	removeAt { arg key;
		var node = envir.at(key);
		var obj;
		^node !? {
			obj = node.obj;
			order.removeNode(node);
		
		}
	}
	
	keysValuesDo { arg function;
		order.doNodes { arg node, i;
			function.value(node.key, node.obj, i)
		}
	}
		
	keysValuesArrayDo { arg array, function;
		order.doNodes { arg node, i;
			function.value(node.key, node.obj, i)
		}
	}
	findKeyForValue { arg val;
		^envir.findKeyForValue(val)
	}
	sortedKeysValuesDo { arg function;
		envir.sortedKeysValuesDo(function);
	}
	putAll { arg ... dictionaries; 
		dictionaries.do {|dict| 
			dict.keysValuesDo { arg key, value; 
				this.put(key, value) 
			}
		}
	}
	
	do { arg func;
		order.do(func)
	}
	
	associationsDo { arg function;
		order.doNodes { arg node, i;
			function.value(node.key -> node.obj, i)
		}
	}
	
	use { arg function;
		// temporarily replaces the currentEnvironment with this, 
		// executes function, returns the result of the function
		var result, saveEnvir;
		
		saveEnvir = currentEnvironment;
		currentEnvironment = this;
		protect {
			result = function.value(this);
		}{
			currentEnvironment = saveEnvir;
		};
		^result
	}	
}